#ifndef CALCPARPANEL_H
#define CALCPARPANEL_H

#include <QtGui>

class CDrawField;
class CCalcEngine;
class CThreeBodyEuler;
class CThreeBodyRK2;
class CThreeBodyRK4;

class CCalcParPanel : public QWidget{
	Q_OBJECT
public:
	CCalcParPanel(CDrawField* f, QWidget* parent=0);
	~CCalcParPanel();
	
	void updateParam();
	void updateAMInfo();

        void setSimEngine(CThreeBodyEuler* p1, CThreeBodyRK2* p2, CThreeBodyRK4* p3){
                peuler=p1; prk2=p2; prk4=p3;
                pengine=(CCalcEngine*)prk2;
	}

public slots:
	void simUpdate();
	
private slots:
        void changeSolver(int id);

private:
	void init();


        CCalcEngine *pengine;
        CThreeBodyEuler *peuler;
        CThreeBodyRK2 *prk2;
        CThreeBodyRK4 *prk4;
        QComboBox *pcmbSolver;
        QLineEdit *ple_nstep, *ple_px, *ple_factor, *ple_av1, *ple_av2, *ple_av3, *ple_avtotal;
	QPushButton *btnZmP, *btnZmM, *btnUpdate;
	CDrawField *field;
};

#endif
